import 'package:flutter/widgets.dart'
    show BuildContext, StatelessWidget, Key, Widget;
import 'package:meedu/get.dart';
import 'package:meedu/state.dart';
import '../builders/simple_builder.dart';

abstract class SimpleWidget<T extends SimpleController>
    extends StatelessWidget {
  /// override this value if you have a tag in your Provider
  final String tag;

  /// override this value if you want updates by id
  final String id;

  const SimpleWidget({Key key, this.tag, this.id}) : super(key: key);

  /// get the controller
  T get controller => Get.i.find<T>(tag: tag);

  /// called every time that the widget needs rebuild
  Widget buildChild(BuildContext context, T controller);

  Widget build(BuildContext context) {
    return SimpleBuilder<T>(
      id: this.id,
      builder: (controller) => buildChild(
        context,
        controller,
      ),
    );
  }
}
